package de.fhdw.wtf.generator.java.generatorModel;

import de.fhdw.wtf.generator.java.visitor.GenTypeVisitor;
import de.fhdw.wtf.generator.java.visitor.GenTypeVisitorException;
import de.fhdw.wtf.generator.java.visitor.GenTypeVisitorReturn;

public final class GenJavaUtilCollection extends GenType {
	// TODO: Remove when generic types are available
	private static final String PACKAGE = "java.util.";
	private static final String NAME = "Collection";
	private static final String GEN_OPEN = "<";
	private static final String GEN_CLOSE = ">";
	private final GenType type;
	
	public GenType getType() {
		return this.type;
	}
	
	public static GenJavaUtilCollection create(final GenType type) {
		return new GenJavaUtilCollection(type);
	}
	
	private GenJavaUtilCollection(final GenType type) {
		super(NAME);
		this.type = type;
	}
	
	@Override
	public String getFullyQualifiedTypeName() {
		return PACKAGE + this.getName();
	}
	
	@Override
	public String getFullyQualifiedTypeNameWithGenericArguments() {
		return this.getFullyQualifiedTypeName() + GEN_OPEN + this.type.getFullyQualifiedTypeNameWithGenericArguments()
				+ GEN_CLOSE;
	}
	
	@Override
	public void accept(final GenTypeVisitor visitor) {
		visitor.handle(this);
		
	}
	
	@Override
	public <X extends java.lang.Exception> void accept(final GenTypeVisitorException<X> visitor) throws X {
		visitor.handle(this);
	}
	
	@Override
	public <X> X accept(final GenTypeVisitorReturn<X> visitor) {
		return visitor.handle(this);
	}
	
}
